/* File: tautonyms.cpp
 *
 * A program to list all tautonyms (words consisting of two identical parts)
 * in English.
 */
 
#include <iostream>
#include <string>
#include "lexicon.h"
using namespace std;

/* Returns whether a word is a tautonym. */
bool isTautonym(string word) {
	/* No odd-length string can be a tautonym. */
	if (word.length() % 2 == 1) {
		return false;
	}
	
	/* Check if the first half and second half of the string are the
	 * same.  Interesting exercise - could you do this by using
	 * == and .substr?
	 */
	for (int i = 0; i < word.length() / 2; i++) {
		if (word[i] != word[i + word.length() / 2]) {
			return false;
		}
	}
	
	return true;
}

int main() {
	Lexicon words("EnglishWords.dat");
	
	foreach (string word in words) {
		if (isTautonym(word)) {
			cout << word << endl;
		}
	}
	
	return 0;
}



